# Generated by Django 3.1.2 on 2020-10-25 21:25

from django.conf import settings
import django.core.validators
from django.db import migrations, models
import django.db.models.deletion
import questionnaire.models.mixins
import questionnaire.models.validators
import uuid


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='Answer',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('made_at', models.DateField(auto_now_add=True)),
                ('updated_at', models.DateField(auto_now=True, null=True)),
            ],
            options={
                'db_table': 'answers',
            },
        ),
        migrations.CreateModel(
            name='Blank',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('title', models.CharField(max_length=255)),
                ('slug', models.SlugField(default='', editable=False, max_length=255, unique=True)),
                ('description', models.TextField(blank=True, null=True)),
                ('is_active', models.BooleanField(default=False)),
                ('is_public', models.BooleanField(default=True)),
                ('with_email_verification', models.BooleanField(default=False)),
                ('owner', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='blanks', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'db_table': 'blanks',
            },
        ),
        migrations.CreateModel(
            name='Participant',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('first_name', models.CharField(max_length=255)),
                ('last_name', models.CharField(max_length=255)),
                ('email', models.EmailField(max_length=254, unique=True)),
                ('user', models.OneToOneField(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='participant_profile', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'db_table': 'questionnaires_participants',
            },
        ),
        migrations.CreateModel(
            name='Question',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('type', models.CharField(choices=[('text_question', 'TEXT'), ('select_question', 'SELECT'), ('multi_select_question', 'MULTI_SELECT'), ('number_question', 'NUMBER')], max_length=50)),
                ('index', models.PositiveSmallIntegerField()),
                ('text', models.TextField()),
                ('post_text', models.TextField(blank=True, null=True)),
                ('is_active', models.BooleanField(default=True)),
                ('is_mandatory', models.BooleanField(default=False)),
                ('blank', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='questions', to='questionnaire.blank')),
            ],
            options={
                'db_table': 'questions',
                'ordering': ('index',),
            },
        ),
        migrations.CreateModel(
            name='MultiSelectAnswer',
            fields=[
                ('value', models.JSONField(blank=True, null=True, validators=[questionnaire.models.validators.ChoicesValidator(255)])),
                ('answer_ptr', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, related_name='multi_select_answer', serialize=False, to='questionnaire.answer')),
            ],
            options={
                'db_table': 'multi_select_answers',
            },
            bases=(questionnaire.models.mixins.CheckQuestionTypeMixin, 'questionnaire.answer'),
        ),
        migrations.CreateModel(
            name='MultiSelectQuestion',
            fields=[
                ('choices', models.JSONField(validators=[questionnaire.models.validators.ChoicesValidator(255)])),
                ('default', models.JSONField(blank=True, null=True, validators=[questionnaire.models.validators.ChoicesValidator(255)])),
                ('question_ptr', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, related_name='multi_select_question', serialize=False, to='questionnaire.question')),
            ],
            options={
                'db_table': 'multi_select_questions',
            },
            bases=(questionnaire.models.mixins.CheckQuestionTypeMixin, 'questionnaire.question'),
        ),
        migrations.CreateModel(
            name='NumberQuestion',
            fields=[
                ('min_value', models.IntegerField()),
                ('max_value', models.IntegerField()),
                ('default', models.IntegerField(blank=True, null=True)),
                ('question_ptr', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, related_name='number_question', serialize=False, to='questionnaire.question')),
            ],
            options={
                'db_table': 'number_questions',
            },
            bases=(questionnaire.models.mixins.CheckQuestionTypeMixin, 'questionnaire.question'),
        ),
        migrations.CreateModel(
            name='NumericalAnswer',
            fields=[
                ('value', models.IntegerField()),
                ('answer_ptr', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, related_name='numerical_answer', serialize=False, to='questionnaire.answer')),
            ],
            options={
                'db_table': 'numerical_answers',
            },
            bases=(questionnaire.models.mixins.CheckQuestionTypeMixin, 'questionnaire.answer'),
        ),
        migrations.CreateModel(
            name='SelectAnswer',
            fields=[
                ('value', models.CharField(max_length=255)),
                ('answer_ptr', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, related_name='select_answer', serialize=False, to='questionnaire.answer')),
            ],
            options={
                'db_table': 'select_answers',
            },
            bases=(questionnaire.models.mixins.CheckQuestionTypeMixin, 'questionnaire.answer'),
        ),
        migrations.CreateModel(
            name='SelectQuestion',
            fields=[
                ('choices', models.JSONField(validators=[questionnaire.models.validators.ChoicesValidator(255)])),
                ('default', models.CharField(blank=True, max_length=255, null=True)),
                ('question_ptr', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, related_name='select_question', serialize=False, to='questionnaire.question')),
            ],
            options={
                'db_table': 'select_questions',
            },
            bases=(questionnaire.models.mixins.CheckQuestionTypeMixin, 'questionnaire.question'),
        ),
        migrations.CreateModel(
            name='TextAnswer',
            fields=[
                ('value', models.TextField(max_length=5000)),
                ('answer_ptr', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, related_name='text_answer', serialize=False, to='questionnaire.answer')),
            ],
            options={
                'db_table': 'text_answers',
            },
            bases=(questionnaire.models.mixins.CheckQuestionTypeMixin, 'questionnaire.answer'),
        ),
        migrations.CreateModel(
            name='TextQuestion',
            fields=[
                ('max_length', models.PositiveIntegerField(default=2000, validators=[django.core.validators.MaxValueValidator(5000)])),
                ('default', models.TextField(blank=True, max_length=5000, null=True)),
                ('question_ptr', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, related_name='text_question', serialize=False, to='questionnaire.question')),
            ],
            options={
                'db_table': 'text_questions',
            },
            bases=(questionnaire.models.mixins.CheckQuestionTypeMixin, 'questionnaire.question'),
        ),
        migrations.CreateModel(
            name='Questionnaire',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False)),
                ('participant_device', models.CharField(max_length=255)),
                ('participant_operation_system', models.CharField(max_length=255)),
                ('participant_browser', models.CharField(max_length=255)),
                ('created_at', models.DateField(auto_now_add=True)),
                ('started_at', models.DateField(blank=True, null=True)),
                ('finished_at', models.DateField(blank=True, null=True)),
                ('blank', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='questionnaires', to='questionnaire.blank')),
                ('participant', models.OneToOneField(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='questionnaires', to='questionnaire.participant')),
            ],
            options={
                'db_table': 'questionnaires',
            },
        ),
        migrations.AddField(
            model_name='answer',
            name='question',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='answers', to='questionnaire.question'),
        ),
        migrations.AddField(
            model_name='answer',
            name='questionnaire',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='answers', to='questionnaire.questionnaire'),
        ),
        migrations.AlterUniqueTogether(
            name='answer',
            unique_together={('question', 'questionnaire')},
        ),
    ]
